Scatter with Images in JavaScript

Using ApexCharts with JavaScript

This Scatter with Images example uses ApexCharts.js directly in JavaScript, with no wrapper component.

Install it with npm install apexcharts, then mount the chart with new ApexCharts(element, options).render().

JavaScript installation guide
var options = {
  series: [
    {
      name: 'Messenger',
      data: [
        [16.4, 5.4],
        [21.7, 4],
        [25.4, 3],
        [19, 2],
        [10.9, 1],
        [13.6, 3.2],
        [10.9, 7],
        [10.9, 8.2],
        [16.4, 4],
        [13.6, 4.3],
        [13.6, 12],
        [29.9, 3],
        [10.9, 5.2],
        [16.4, 6.5],
        [10.9, 8],
        [24.5, 7.1],
        [10.9, 7],
        [8.1, 4.7],
        [19, 10],
        [27.1, 10],
        [24.5, 8],
        [27.1, 3],
        [29.9, 11.5],
        [27.1, 0.8],
        [22.1, 2],
      ],
    },
    {
      name: 'Instagram',
      data: [
        [6.4, 5.4],
        [11.7, 4],
        [15.4, 3],
        [9, 2],
        [10.9, 11],
        [20.9, 7],
        [12.9, 8.2],
        [6.4, 14],
        [11.6, 12],
        [18.2, 9],
        [22.5, 5.5],
        [25.1, 8],
        [14.3, 6],
        [8.7, 9.5],
        [17.6, 13],
        [23.8, 11],
        [28.4, 6.5],
        [30.9, 9],
        [26.2, 4],
        [19.5, 2.5],
        [13.1, 10.5],
        [21.4, 12.5],
        [16.8, 4.8],
        [29.7, 12],
        [24.3, 7.8],
      ],
    },
  ],
  chart: {
    height: 350,
    type: 'scatter',
    animations: {
      enabled: false,
    },
    zoom: {
      enabled: false,
    },
    toolbar: {
      show: false,
    },
  },
  colors: ['#056BF6', '#D2376A'],
  xaxis: {
    tickAmount: 10,
    min: 0,
    max: 40,
  },
  yaxis: {
    tickAmount: 7,
  },
  markers: {
    size: 20,
  },
  fill: {
    type: 'image',
    opacity: 1,
    image: {
      src: [
        '../../assets/images/ico-messenger.png',
        '../../assets/images/ico-instagram.png',
      ],
      width: 40,
      height: 40,
    },
  },
  legend: {
    labels: {
      useSeriesColors: true,
    },
    markers: {
      customHTML: [
        function () {
          return '<img src="../../assets/images/ico-messenger.png" width="16" height="16" />'
        },
        function () {
          return '<img src="../../assets/images/ico-instagram.png" width="16" height="16" />'
        },
      ],
    },
  },
}

var chart = new ApexCharts(document.querySelector('#chart'), options)
chart.render()

Scatter with Images in Angular

Using ApexCharts with Angular

This Scatter with Images example wires ApexCharts into Angular through the ng-apexcharts component.

Install it with npm install ng-apexcharts apexcharts, then mount the chart with <apx-chart [series]="series" [chart]="chart"></apx-chart>.

Angular charts guide

This demo uses imperative chart updates. The generated code is a faithful Angular translation: open it in CodeSandbox to run and tweak.

import { Component, AfterViewInit, OnDestroy, ViewChild } from '@angular/core';
import {
  ChartComponent,
  ApexAxisChartSeries,
  ApexNonAxisChartSeries,
  ApexChart,
  ApexXAxis,
  ApexYAxis,
  ApexTitleSubtitle,
  ApexDataLabels,
  ApexStroke,
  ApexFill,
  ApexLegend,
  ApexTooltip,
  ApexMarkers,
  ApexPlotOptions,
  ApexResponsive,
  ApexGrid,
  ApexAnnotations,
  ApexStates,
  ApexTheme,
  NgApexchartsModule,
} from 'ng-apexcharts';

export type ChartOptions = {
  series?: ApexAxisChartSeries | ApexNonAxisChartSeries;
  chart?: ApexChart;
  xaxis?: ApexXAxis;
  yaxis?: ApexYAxis | ApexYAxis[];
  title?: ApexTitleSubtitle;
  subtitle?: ApexTitleSubtitle;
  dataLabels?: ApexDataLabels;
  stroke?: ApexStroke;
  fill?: ApexFill;
  legend?: ApexLegend;
  tooltip?: ApexTooltip;
  markers?: ApexMarkers;
  plotOptions?: ApexPlotOptions;
  responsive?: ApexResponsive[];
  grid?: ApexGrid;
  annotations?: ApexAnnotations;
  states?: ApexStates;
  theme?: ApexTheme;
  colors?: string[];
  labels?: any;
};

@Component({
  selector: 'app-chart',
  standalone: true,
  imports: [NgApexchartsModule],
  templateUrl: './chart.component.html',
})
export class AppChart implements AfterViewInit, OnDestroy {
  @ViewChild('chart') chart!: ChartComponent;
  public chartOptions: Partial<ChartOptions> = {
          series: [
            {
              name: 'Messenger',
              data: [
                [16.4, 5.4],
                [21.7, 4],
                [25.4, 3],
                [19, 2],
                [10.9, 1],
                [13.6, 3.2],
                [10.9, 7],
                [10.9, 8.2],
                [16.4, 4],
                [13.6, 4.3],
                [13.6, 12],
                [29.9, 3],
                [10.9, 5.2],
                [16.4, 6.5],
                [10.9, 8],
                [24.5, 7.1],
                [10.9, 7],
                [8.1, 4.7],
                [19, 10],
                [27.1, 10],
                [24.5, 8],
                [27.1, 3],
                [29.9, 11.5],
                [27.1, 0.8],
                [22.1, 2],
              ],
            },
            {
              name: 'Instagram',
              data: [
                [6.4, 5.4],
                [11.7, 4],
                [15.4, 3],
                [9, 2],
                [10.9, 11],
                [20.9, 7],
                [12.9, 8.2],
                [6.4, 14],
                [11.6, 12],
                [18.2, 9],
                [22.5, 5.5],
                [25.1, 8],
                [14.3, 6],
                [8.7, 9.5],
                [17.6, 13],
                [23.8, 11],
                [28.4, 6.5],
                [30.9, 9],
                [26.2, 4],
                [19.5, 2.5],
                [13.1, 10.5],
                [21.4, 12.5],
                [16.8, 4.8],
                [29.7, 12],
                [24.3, 7.8],
              ],
            },
          ],
          chart: {
            height: 350,
            type: 'scatter',
            animations: {
              enabled: false,
            },
            zoom: {
              enabled: false,
            },
            toolbar: {
              show: false,
            },
          },
          colors: ['#056BF6', '#D2376A'],
          xaxis: {
            tickAmount: 10,
            min: 0,
            max: 40,
          },
          yaxis: {
            tickAmount: 7,
          },
          markers: {
            size: 20,
          },
          fill: {
            type: 'image',
            opacity: 1,
            image: {
              src: [
                'https://apexcharts.com/samples/assets/images/ico-messenger.png',
                'https://apexcharts.com/samples/assets/images/ico-instagram.png',
              ],
              width: 40,
              height: 40,
            },
          },
          legend: {
            labels: {
              useSeriesColors: true,
            },
            markers: {
              customHTML: [
                function () {
                  return '<img src="https://apexcharts.com/samples/assets/images/ico-messenger.png" width="16" height="16" />'
                },
                function () {
                  return '<img src="https://apexcharts.com/samples/assets/images/ico-instagram.png" width="16" height="16" />'
                },
              ],
            },
          },
        };
  ngAfterViewInit() {
    (window as any).ApexCharts.setLicense('APEX-eyJleHBpcnlEYXRlIjoiMjEyNi0wNy0wNCIsImlzc3VlRGF0ZSI6IjIwMjYtMDctMjgiLCJwbGFuIjoicHJlbWl1bSIsImRvbWFpbnMiOlsiYXBleGNoYXJ0cy5jb20iLCIxMjcuMC4wLjEiLCJsb2NhbGhvc3QiXSwic2lnIjoieVBmb1VCc0Z3TU9ZdUEyaEZkR0I2Y1FtZ0JITUtXcVdJSjB2NVRESXRZbFR3eDJMUmh6R2x0RUc3VXJ4X0s3b25ZMWRZb2Z2VGItN01ydFYyNDVyOWcifQ==');
  }

  ngOnDestroy() {
    // no cleanup needed
  }
}

Scatter with Images in React

Using ApexCharts with React

This Scatter with Images example wires ApexCharts into React through the react-apexcharts component.

Install it with npm install react-apexcharts apexcharts, then mount the chart with <Chart type="..." options={options} series={series} />.

React charts guide
import React from 'react'
import ReactApexChart from 'react-apexcharts'
import './styles.css'

// This demo also loads: https://apexcharts.com/samples/assets/styles.css

const ApexChart = () => {
  const [state, setState] = React.useState({
    series: [
      {
        name: 'Messenger',
        data: [
          [16.4, 5.4],
          [21.7, 4],
          [25.4, 3],
          [19, 2],
          [10.9, 1],
          [13.6, 3.2],
          [10.9, 7],
          [10.9, 8.2],
          [16.4, 4],
          [13.6, 4.3],
          [13.6, 12],
          [29.9, 3],
          [10.9, 5.2],
          [16.4, 6.5],
          [10.9, 8],
          [24.5, 7.1],
          [10.9, 7],
          [8.1, 4.7],
          [19, 10],
          [27.1, 10],
          [24.5, 8],
          [27.1, 3],
          [29.9, 11.5],
          [27.1, 0.8],
          [22.1, 2],
        ],
      },
      {
        name: 'Instagram',
        data: [
          [6.4, 5.4],
          [11.7, 4],
          [15.4, 3],
          [9, 2],
          [10.9, 11],
          [20.9, 7],
          [12.9, 8.2],
          [6.4, 14],
          [11.6, 12],
          [18.2, 9],
          [22.5, 5.5],
          [25.1, 8],
          [14.3, 6],
          [8.7, 9.5],
          [17.6, 13],
          [23.8, 11],
          [28.4, 6.5],
          [30.9, 9],
          [26.2, 4],
          [19.5, 2.5],
          [13.1, 10.5],
          [21.4, 12.5],
          [16.8, 4.8],
          [29.7, 12],
          [24.3, 7.8],
        ],
      },
    ],
    options: {
      chart: {
        height: 350,
        type: 'scatter',
        animations: {
          enabled: false,
        },
        zoom: {
          enabled: false,
        },
        toolbar: {
          show: false,
        },
      },
      colors: ['#056BF6', '#D2376A'],
      xaxis: {
        tickAmount: 10,
        min: 0,
        max: 40,
      },
      yaxis: {
        tickAmount: 7,
      },
      markers: {
        size: 20,
      },
      fill: {
        type: 'image',
        opacity: 1,
        image: {
          src: [
            '../../assets/images/ico-messenger.png',
            '../../assets/images/ico-instagram.png',
          ],
          width: 40,
          height: 40,
        },
      },
      legend: {
        labels: {
          useSeriesColors: true,
        },
        markers: {
          customHTML: [
            function () {
              return '<img src="../../assets/images/ico-messenger.png" width="16" height="16" />'
            },
            function () {
              return '<img src="../../assets/images/ico-instagram.png" width="16" height="16" />'
            },
          ],
        },
      },
    },
  })

  return (
    <div>
      <div id="chart">
        <ReactApexChart
          options={state.options}
          series={state.series}
          type="scatter"
          height={350}
        />
      </div>
    </div>
  )
}

export default ApexChart

Scatter with Images in Vue

Using ApexCharts with Vue

This Scatter with Images example wires ApexCharts into Vue through the vue3-apexcharts component.

Install it with npm install vue3-apexcharts apexcharts, then mount the chart with <apexchart type="..." :options="options" :series="series" />.

Vue charts guide
<template>
  <div>
    <div id="chart">
      <apexchart
        type="scatter"
        height="350"
        :options="chartOptions"
        :series="series"
      ></apexchart>
    </div>
  </div>
</template>

<script>
import VueApexCharts from 'vue-apexcharts'

// This demo also loads: https://apexcharts.com/samples/assets/styles.css

export default {
  components: {
    apexchart: VueApexCharts,
  },
  data: function () {
    return {
      series: [
        {
          name: 'Messenger',
          data: [
            [16.4, 5.4],
            [21.7, 4],
            [25.4, 3],
            [19, 2],
            [10.9, 1],
            [13.6, 3.2],
            [10.9, 7],
            [10.9, 8.2],
            [16.4, 4],
            [13.6, 4.3],
            [13.6, 12],
            [29.9, 3],
            [10.9, 5.2],
            [16.4, 6.5],
            [10.9, 8],
            [24.5, 7.1],
            [10.9, 7],
            [8.1, 4.7],
            [19, 10],
            [27.1, 10],
            [24.5, 8],
            [27.1, 3],
            [29.9, 11.5],
            [27.1, 0.8],
            [22.1, 2],
          ],
        },
        {
          name: 'Instagram',
          data: [
            [6.4, 5.4],
            [11.7, 4],
            [15.4, 3],
            [9, 2],
            [10.9, 11],
            [20.9, 7],
            [12.9, 8.2],
            [6.4, 14],
            [11.6, 12],
            [18.2, 9],
            [22.5, 5.5],
            [25.1, 8],
            [14.3, 6],
            [8.7, 9.5],
            [17.6, 13],
            [23.8, 11],
            [28.4, 6.5],
            [30.9, 9],
            [26.2, 4],
            [19.5, 2.5],
            [13.1, 10.5],
            [21.4, 12.5],
            [16.8, 4.8],
            [29.7, 12],
            [24.3, 7.8],
          ],
        },
      ],
      chartOptions: {
        chart: {
          height: 350,
          type: 'scatter',
          animations: {
            enabled: false,
          },
          zoom: {
            enabled: false,
          },
          toolbar: {
            show: false,
          },
        },
        colors: ['#056BF6', '#D2376A'],
        xaxis: {
          tickAmount: 10,
          min: 0,
          max: 40,
        },
        yaxis: {
          tickAmount: 7,
        },
        markers: {
          size: 20,
        },
        fill: {
          type: 'image',
          opacity: 1,
          image: {
            src: [
              '../../assets/images/ico-messenger.png',
              '../../assets/images/ico-instagram.png',
            ],
            width: 40,
            height: 40,
          },
        },
        legend: {
          labels: {
            useSeriesColors: true,
          },
          markers: {
            customHTML: [
              function () {
                return '<img src="../../assets/images/ico-messenger.png" width="16" height="16" />'
              },
              function () {
                return '<img src="../../assets/images/ico-instagram.png" width="16" height="16" />'
              },
            ],
          },
        },
      },
    }
  },
}
</script>

<style>
#chart {
  max-width: 650px;
  margin: 35px auto;
}
.apexcharts-legend {
  overflow: hidden !important;
  min-height: 17px;
}
.apexcharts-legend-marker {
  background: none !important;
  margin-right: 7px !important;
}
.apexcharts-legend-series {
  align-items: flex-start !important;
}
</style>